<template>
<div class="wrapper">
  <div class="title-container">
    <div @click="titleClicked">
      <h1>Crypto Jobs 🔒</h1>
      <h3>Databáze blockchain/crypto prací v 🇨🇿 ČR a na 🇸🇰 Slovensku</h3>
    </div>
    <router-link class="add-job"
    :to="{ name: 'JobSubmit' }">
      Přidat Pracovní Nabídku
    </router-link>
  </div>

  <div class="social">
    <a class="facebook"
    target="_blank"
    href="https://www.facebook.com/CryptoJobs-CZSK-157808408267430/">
      <font-awesome-icon :icon="facebookIcon"/> Sledovat na Facebooku
    </a>

    <a class="twitter"
    target="_blank"
    href="https://twitter.com/cryptojobsczsk">
      <font-awesome-icon :icon="twitterIcon"/> Sledovat na Twitteru
    </a>
  </div>

  <!-- <div class="controls">
    <div class="search">
      <input
      class="search-input"
      type="text"
      placeholder="🔍 Trader, Blockchain, Design,...">
    </div>
  </div> -->

  <!-- <div class="jobs-featured">
    <h2 class="title">Nejžhavější nabídky 🔥</h2>

    <div class="jobs-list">
      <JobCard/>
      <JobCard/>
    </div>
  </div> -->

  <div class="jobs-newest">
    <h2 class="title">Nejnovější pracovní nabídky 🗓</h2>

    <div class="jobs-list"
    v-for="(job, index) in jobs"
    :key="index">
      <JobCard
      :job="job"/>
    </div>
  </div>

  <infinite-loading @infinite="onInfinite"
  :spinner="infiniteSpinner">
    <span slot="no-more">
      A to je vše 💁‍♀️
    </span>
  </infinite-loading>
</div>
</template>

<script>
import InfiniteLoading from 'vue-infinite-loading';
import JobCard from '@/components/JobCard';
import JobService from '@/mixins/JobService';
import FontAwesomeIcon from '@fortawesome/vue-fontawesome';
import { faFacebook, faTwitter } from '@fortawesome/fontawesome-free-brands';

export default {
  name: 'AppHome',
  mixins: [JobService],
  components: {
    InfiniteLoading,
    JobCard,
    FontAwesomeIcon,
  },
  data() {
    return {
      jobs: [],
      infiniteSpinner: 'waveDots',
      lastJob: null,
      batchSize: 10,
    };
  },
  computed: {
    facebookIcon() {
      return faFacebook;
    },
    twitterIcon() {
      return faTwitter;
    },
  },
  methods: {
    titleClicked() {
      this.$router.push({ name: 'AppHome' });
    },
    async onInfinite($state) {
      const isFirstBatch = !this.lastJob;
      try {
        const snapshots = await this.getJobs(isFirstBatch, this.lastJob, this.batchSize);
        if (snapshots.docs.length) {
          this.lastJob = snapshots.docs[snapshots.docs.length - 1];
          this.jobs.push(...snapshots.docs.map(s => s.data()));
          $state.loaded();
        } else {
          $state.complete();
        }
      } catch (e) {
        $state.complete();
      }
    },
  },
};
</script>

<style scoped>
.wrapper {
  display: flex;
  flex-direction: column;
  justify-content: center;
}

/* <Title Container> */
.title-container {
  display: flex;
  flex-direction: column;
  align-items: flex-start;

  cursor: pointer;

  margin: 70px 0 70px;
}

.title-container h1, h3 {
  text-align: left;
}

.title-container h1 {
  margin: 0;
  font-weight: 900;
}

.title-container h3 {
  margin-top: 0;
}

.title-container .add-job {
  padding: 5px 12px;
  border-radius: 4px;

  font-weight: 700;
  font-size: 1.2em;
  color: #fff;
  text-decoration: none;

  background-color: #a55eea;

  box-shadow: 0 12px 25px rgba(0,0,0,0.04);
  transition: all .24s cubic-bezier(0,.5,.51,1);
}

.title-container .add-job:visited {
  color: #fff;
}

.title-container .add-job:hover {
  box-shadow: 0 14px 25px rgba(0,0,0,0.08);
  transform: scale(1.04);
}
/* </Title Container> */


/* <Social> */
.social {
  display: flex;
  flex-direction: row;
}

.social > a {
  padding: 5px 12px;
  border-radius: 4px;

  font-weight: 700;
  font-size: 1.0em;
  color: #fff;
  text-decoration: none;

  box-shadow: 0 12px 25px rgba(0,0,0,0.04);
}

.social > .facebook {
  margin: 0 10px 0 0;
  background-color: #3b5998;
}

.social > .twitter {
  margin: 0 0 0 10px;
  background-color: #00aced;
}
/* </Social> */

/* <Search> */
.controls {
  display: flex;
  flex-direction: column;
  justify-content: center;
}

.search-input {
  padding-left: 0.5em;

  height: 2.6em;
  min-width: 450px;

  border: 1.4px solid #e1e1e1;
  border-radius: 4px;

  font-size: 1.0em;
  font-weight: 700;
}
/* <Search/> */

/* <Jobs> */
.jobs-featured, .jobs-newest {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
}

.jobs-featured, .jobs-newest > .title {
  text-align: left;
}

.jobs-list {
  min-width: 100%;
}
/* </Jobs> */

@media screen and (max-width: 768px) {
  .search-input {
    min-width: 290px;
  }
}
</style>
